//Modified, copying and csv added by Tarvo Korrovits
//in October, 2001,
//originally made by Varun Ranjit Singh,
//distributed under GNU General Public License
//(there is no warranty)
//http://sourceforge.net/projects/tkorrovi

#include <windows.h>
#include <malloc.h>
#include "concalc.h"

CELLPTR cell [MAXCOLS] [MAXROWS], curcell;
unsigned char format [MAXCOLS] [MAXROWS];
unsigned char colwidth [MAXCOLS];
unsigned char colstart [SCREENCOLS];
int leftcol, rightcol, toprow, bottomrow, curcol, 
  currow, lastcol, lastrow, curcolb, currowb, curcolc, 
  currowc, curcolcb, currowcb, i, j, leftcolb, toprowb,
  loading;
char changed = FALSE, formdisplay = FALSE,
  autocalc = TRUE, stop = FALSE, str [MAXINPUT + 1];
unsigned int shortcursor = 0x0607, tallcursor = 0x0507, normalcursor = 0x0407,
  nocursor = 0x2000, c, ac, outc;
MEMORYSTATUS memstatus;
CONSOLE_CURSOR_INFO curinfo;
INPUT_RECORD inp;
HANDLE si, so;
DWORD written;
BOOL correctkey;
COORD coord;
CHAR_INFO charinfo;
SMALL_RECT R;

//main program loop
void run ()
{
  int input;
  CELLPTR cellptr1, cellptr2;
  do
  {
    if (curcol == curcolb && currow == currowb)
      displaycell (curcol, currow, HIGHLIGHT, NOUPDATE);
    else
      displayscreen (NOUPDATE);
    curcell = cell [curcol] [currow];
    showcelltype ();
    input = getkey ();
    switch (input)
    {
      case '/': mainmenu (); break;
      case F9: recalc (); break;
      case F2: editcell (curcell); break;
     
      case DELKEY:
        for (i = currow; i <= currowb; i++)
          for (j = curcol; j <= curcolb; j++)
            deletecell (j, i, UPDATE);
        printfreemem ();
        if (autocalc) recalc ();
      break;
     
      case PGUPKEY:
        if (curcolb == curcol && currowb == currow)
        {
          toprow -= 20;
          currow -= 20;
          if (currow < 0)
            currow = toprow = 0;
          else
            if (toprow < 0)
            {
              currow -= toprow;
              toprow = 0;
            }
          currowb = currow;
          setbottomrow ();
          displayscreen (NOUPDATE);
        }
      break;
     
      case PGDNKEY:
        if (curcolb == curcol && currowb == currow)
        {
          toprow += 20;
          currow += 20;
          if ((currow >= MAXROWS) && (toprow >= MAXROWS))
          {
            currow = MAXROWS - 1;
            toprow = MAXROWS - 20;
          }
          else
            if (toprow > (MAXROWS - 20))
            {
              currow -= (toprow + 20 - MAXROWS);
              toprow = MAXROWS - 20;
            }
          currowb = currow;
          setbottomrow ();
          displayscreen (NOUPDATE);
        }
      break;
     
      case CTRLLEFTKEY:
        if (curcolb == curcol && currowb == currow)
        {
          displaycell (curcol, currow, NOHIGHLIGHT, 
            NOUPDATE);
          if (leftcol == 0)
          {
            curcol = 0;
            curcolb = curcol;
          }
          else
          {
            curcol = rightcol = leftcol - 1;
            curcolb = curcol;
            setleftcol ();
            setrightcol ();
            displayscreen (NOUPDATE);
          }
        }
      break;
     
      case CTRLRIGHTKEY:
        if (curcolb == curcol && currowb == currow)
        {
          displaycell (curcol, currow, NOHIGHLIGHT, 
            NOUPDATE);
          if (rightcol == MAXCOLS - 1)
          {
            curcol = rightcol;
            curcolb = curcol;
          }
          else
          {
            curcol = leftcol = rightcol + 1;
            curcolb = curcol;
            setrightcol ();
            setleftcol ();
            displayscreen (NOUPDATE);
          }
        }
      break;
     
      case HOMEKEY:
        if (curcolb == curcol && currowb == currow)
        {
          currow = curcol = leftcol = toprow = 0;
          currowb = currow;
          curcolb = curcol;
          setrightcol ();
          setbottomrow ();
          displayscreen (NOUPDATE);
        }
      break;
     
      case ENDKEY:
        if (curcolb == curcol && currowb == currow)
        {
          rightcol = curcol = lastcol;
          currow = bottomrow = lastrow;
          currowb = currow;
          curcolb = curcol;
          settoprow ();
          setleftcol ();
          setrightcol ();
          displayscreen (NOUPDATE);
        }
      break;
     
      case UPKEY:
        if (curcolb != curcol || currowb != currow)
        { 
          curcolb = curcol;
          currowb = currow;
          leftcol = leftcolb;
          toprow = toprowb;
          setbottomrow ();
          setrightcol ();
          setleftcol ();
          displayscreen (NOUPDATE);
        }
        else
          moverowup ();
      break;
      
      case DOWNKEY: 
        if (curcolb != curcol || currowb != currow)
        { 
          curcolb = curcol;
          currowb = currow;
          leftcol = leftcolb;
          toprow = toprowb;
          setbottomrow ();
          setrightcol ();
          setleftcol ();
          displayscreen (NOUPDATE);
        }
        else
          moverowdown (); 
      break;
      
      case LEFTKEY: 
        if (curcolb != curcol || currowb != currow)
        { 
          curcolb = curcol;
          currowb = currow;
          leftcol = leftcolb;
          toprow = toprowb;
          setbottomrow ();
          setrightcol ();
          setleftcol ();
          displayscreen (NOUPDATE);
        }
        else
          movecolleft (); 
      break;
      
      case RIGHTKEY:
        if (curcolb != curcol || currowb != currow)
        { 
          curcolb = curcol;
          currowb = currow;
          leftcol = leftcolb;
          toprow = toprowb;
          setbottomrow ();
          setrightcol ();
          setleftcol ();
          displayscreen (NOUPDATE);
        }
        else
          movecolright ();
      break;
      
      case SHIFTUPKEY:
        if (currow <= currowb - 1)
        {
          currowb--;
          if (curcol == curcolb && currow == currowb)
            displayscreen (NOUPDATE);
          else
            moverowup ();
        }
      break;
      
      case SHIFTDOWNKEY:
        if (currowb == currow && curcolb == curcol)
        {
          leftcolb = leftcol;
          toprowb = toprow;
        }
        if (MAXROWS >= currowb + 1)
        { 
          currowb++;
          moverowdown ();
        }
      break;
      
      case SHIFTLEFTKEY:
        if (curcol <= curcolb - 1)
        {
          curcolb--;
          if (curcol == curcolb && currow == currowb)
            displayscreen (NOUPDATE);
          else
            movecolleft ();
        }
      break;
      
      case SHIFTRIGHTKEY:
        if (currowb == currow && curcolb == curcol)
        {
          leftcolb = leftcol;
          toprowb = toprow;
        }
        if (MAXROWS >= curcolb + 1)
        { 
          curcolb++;
          movecolright ();
        }
      break;
      
      case CTRLC:
        curcolc = curcol;
        currowc = currow;
        curcolcb = curcolb;
        currowcb = currowb;
      break;
      
      //it can be done better, if necessary, by 
      //iterating backwards sometimes
      case CTRLV:
        if (curcolb == curcol && currowb == currow &&
          curcol + curcolcb - curcolc + 1 <= MAXCOLS &&
          currow + currowcb - currowc + 1 <= MAXROWS &&
          (curcolcb < curcol || 
          curcolc > curcol + curcolcb - curcolc ||
          currowcb < currow ||
          currowc > currow + currowcb - currowc))
        {
          for (i = currow; i <= currow + currowcb - 
            currowc; i++)
            for (j = curcol; j <= curcol + curcolcb -
              curcolc; j++)
            {
              format [j] [i] = 
                format [j - curcol + curcolc]
                [i - currow + currowc];
              deletecell (j, i, UPDATE);
              if (cell [j - curcol + curcolc]
                [i - currow + currowc] != NULL)
              {
                cellptr1 = cell [j - curcol + curcolc]
                  [i - currow + currowc];
                if (cellptr1->attrib == TEXTCELL)
                  act2 (cellptr1->v.text, 0, 
                    cellptr1->attrib);
                if (cellptr1->attrib == FORMULA)
                  act2 (cellptr1->v.f.formula,
                    cellptr1->v.f.fvalue,
                    cellptr1->attrib);
                if (cellptr1->attrib == VALUE)
                  act2 (NULL, cellptr1->v.value, 
                    cellptr1->attrib);
                if (cell [j] [i] != NULL &&
                  cell [j] [i]->attrib == FORMULA)
                  fixformula2 (j, i);
              }
            }
          if (autocalc) recalc ();
          displayscreen (NOUPDATE);
        }
      break;
      
      case ALTF4:
        checkforsave();
        stop = TRUE;
      break;
      
      case ESC: case BS: case CR: case INSKEY: 
      case TABKEY: case F4:
      break;
      
      default:
        getinput (input);
      break;
    }
  } 
  while (!stop);
}

int main (int argc, char *argv [])
{
  si = GetStdHandle (STD_INPUT_HANDLE);
  so = GetStdHandle (STD_OUTPUT_HANDLE);
  SetConsoleMode (si, ENABLE_WINDOW_INPUT);
  SetConsoleTitle (MSGTITLE);
  setcursor (shortcursor);
  setcursor (nocursor);
  loading = 0;
  clrscr ();
  initvars ();
  redrawscreen ();
  if (argc > 1) loadsheet (argv [1]);
  clearinput ();
  run ();

  setcursor (normalcursor);


  return 0;
}

