#define S_IREAD	 0x0100	
#define S_IWRITE 0x0080	

#define TRUE 1
#define FALSE 0

#define MSGTITLE "concalc 1.2, distribuido bajo la Licencia General y Publica GNU (sin garantias)"
#define MSGABOUT1 "Acerca de este programa: modificado, copiado y soporte csv aadido por Tarvo "
#define MSGABOUT2 "Korrovits,  originalmente hecho por Varun Ranjit Singh                       "
#define MSGKEYPRESS "Presione cualquier tecla para continuar."
#define MSGCOMMAND "Presione / para ver la lista de comandos"
#define MSGMEMORY "Memoria Disp.:"
#define MSGERROR "ERROR"
#define MSGLOMEM "No hay suficiente memoria para allocate la celda."
#define MSGEMPTY "Vacio"
#define MSGTEXT  "Texto"
#define MSGVALUE "Valor"
#define MSGFORMULA "Formula"
#define MSGAUTOCALC "AutoCalc"
#define MSGFORMDISPLAY "Forma"
#define MSGFILENAME "Ingrese el nombre de la Hoja de Calculo:"
#define MSGCOLWIDTH "Ingrese el nuevo ancho de Columna:"
#define MSGNOOPEN "No se puede abrir el archivo."
#define MSGOVERWRITE "El archivo ya existe, Desea sobreescribirlo?"
#define MSGFILELOMEM "No hay suficiente memoria para toda la Hoja de Calculo."
#define MSGNOEXIST "El archivo no existe."
#define MSGGOTO "Ingrese la Celda a la que desea ir:"
#define MSGBADNUMBER "Debe ingresar un numero desde %d hasta %d."
#define MSGBADCELL "Esa no es una celda legal."
#define MSGCELL1 "Ingrese la primera celda a formatear:"
#define MSGCELL2 "Ingrese la ultima celda a formatear:"
#define MSGDIFFCOLROW "La fila de la columna debe ser la misma."
#define MSGRIGHTJUST "Desea la celda justificada a la derecha?"
#define MSGDOLLAR "Desea los numeros en formato de dolar?"
#define MSGCOMMAS "Desea comas en los numeros?"
#define MSGPLACES "A cuantos digitos decimales se debe redondear el numero?"
#define MSGCOLUMNS "Desea imprimir en 132 columnas?"
#define MSGPRINT "Ingrese el nombre del Archivo de Impresion, o presione ENTER para Imprimir."
#define MSGBORDER "Imprimir el Borde?"
#define MSGLOADING "Cargando..."
#define MSGSAVING "Grabando..."
#define MSGSAVESHEET "Graba la Hoja de Calculo actual?"
#define MSGSTACKERROR "Desborde de la Pila del Analizador."
#define MSGIOERROR "Error de E/S"

#define MENU "Hojadecalculo, Formato, Borrar, Ir a, Col, Fil, Editar, Util., Auto, Salir"
#define COMMAND "HFBICFEUAS"
#define SMENU "Cargar, Grabar, Imprimir, Limpiar, Acerca de"
#define SCOMMAND "CGILA"
#define CMENU "Insertar, Borrar, Ancho"
#define CCOMMAND "IBA"
#define RMENU "Insertar, Borrar"
#define RCOMMAND "IB"
#define UMENU "Recalcular, Mostrar Formula"
#define UCOMMAND "RM"
#define KEYS_YESNO "SN"

#define MAXCOLS 100
#define MAXROWS 999
#define LEFTMARGIN 3
#define MINCOLWIDTH 3
#define MAXCOLWIDTH 80 - LEFTMARGIN
#define SCREENCOLS (80 - LEFTMARGIN) / MINCOLWIDTH + 1
#define SCREENROWS 20
#define DEFAULTWIDTH 10
#define DEFAULTFORMAT 0X42
#define MAXINPUT 79
#define MAXPLACES 8
#define TOPMARGIN 5
#define PARSERSTACKSIZE 20

enum COLORS {BLACK, BLUE, GREEN, CYAN, RED, MAGENTA,
  BROWN, LIGHTGRAY, DARKGRAY, LIGHTBLUE, LIGHTGREEN,
  LIGHTCYAN, LIGHTRED, LIGHTMAGENTA, YELLOW, WHITE};

#define TEXTCOLOR BLACK + 16 * WHITE
#define ERRORCOLOR RED + 16 * WHITE
#define VALUECOLOR CYAN + 16 * WHITE
#define FORMULACOLOR MAGENTA + 16 * WHITE
#define BLANKCOLOR WHITE + 16 * WHITE
#define HEADERCOLOR WHITE + 16 * CYAN
#define HIGHLIGHTCOLOR WHITE + 16 * DARKGRAY
#define HIGHLIGHTERRORCOLOR WHITE + 16 * RED
#define MSGAUTOCALCCOLOR CYAN + 16 * WHITE
#define MSGFORMDISPLAYCOLOR MAGENTA + 16 * WHITE
#define MSGMEMORYCOLOR GREEN + 16 * WHITE
#define MSGHEADERCOLOR CYAN + 16 * WHITE
#define PROMPTCOLOR BROWN + 16 * WHITE
#define COMMANDCOLOR CYAN + 16 * WHITE
#define LOWCOMMANDCOLOR BLACK + 16 * WHITE
#define MEMORYCOLOR RED + 16 * WHITE
#define CELLTYPECOLOR GREEN + 16 * WHITE
#define CELLCONTENTSCOLOR BROWN + 16 * WHITE

#define HIGHLIGHT TRUE
#define NOHIGHLIGHT FALSE
#define UPDATE TRUE
#define NOUPDATE FALSE
#define FORMAT TRUE
#define NOFORMAT FALSE
#define LEFT 0
#define RIGHT 1
#define UP 2
#define DOWN 3
#define TEXTCELL 0
#define VALUE 1
#define FORMULA 2
#define COLADD 0
#define COLDEL 1
#define ROWADD 2
#define ROWDEL 3
#define OVERWRITE 0X80
#define RJUSTIFY 0X40
#define COMMAS 0X20
#define DOLLAR 0X10

struct CELLREC
{
  char attrib;
  union
  {
    char text [MAXINPUT + 1];
    double value;
    struct
    {
      double fvalue;
      char formula [MAXINPUT + 1];
    } f;
  } v;
};

typedef struct CELLREC *CELLPTR;

#define BS 8
#define FORMFEED 12
#define CR 13
#define ESC 27
#define HOMEKEY 327
#define ENDKEY 335
#define UPKEY 328
#define DOWNKEY 336
#define PGUPKEY 329
#define PGDNKEY 337
#define LEFTKEY 331
#define INSKEY 338
#define RIGHTKEY 333
#define DELKEY 339
#define CTRLLEFTKEY 371
#define CTRLRIGHTKEY 372
#define F9 315
#define F2 316
#define SHIFTUPKEY 401
#define SHIFTDOWNKEY 402
#define SHIFTLEFTKEY 403
#define SHIFTRIGHTKEY 404
#define CTRLC 405
#define CTRLV 406
#define ALTF4 407
#define F4 408
#define TABKEY 409

#define PLUS 0
#define MINUS 1
#define TIMES 2
#define DIVIDE 3
#define EXP 4
#define COLON 5
#define OPAREN 6
#define CPAREN 7
#define NUM 8
#define CELL 9
#define FUNC 10
#define EOLN 11
#define BAD 12
#define MAXFUNCNAMELEN 5
#define RPLUS 1
#define RMINUS 2
#define RTIMES 4
#define RDIVIDE 5
#define RPOW 7
#define RNEGATE 9
#define RSUM 11
#define RCELLVALUE 13
#define RFUNC 16
#define RNUM 15
#define RCPAREN 14
#define RFIRSTPOW 6
#define RFIRSTNEGATE 8
#define RFIRSTSUM 10
#define RFIRSTFUNC 12
#define RFIRSTTIMES 3
#define SNUM 10
#define SCELL 7
#define SFUNC 11
#define SNEGATE 5
#define SOPAREN 9
#define SPLUS 12
#define SMINUS 13
#define STIMES 14
#define SDIVIDE 15
#define SFIRST 0
#define SPOW 16
#define SCOLON 18
#define SFOPAREN 20
#define SDONEGATE 17
#define SDOTIMES 23
#define SDODIVIDE 24
#define SDOPOW 25
#define SDOSUM 26
#define SDOFUNC 29
#define SERROR 30
#define SCPAREN 27
#define SFIRSTPLUS 1
#define SOPARENPLUS 19
#define SFOPARENPLUS 28
#define SFIRSTTIMES 2
#define SFIRSTPOW 3
#define SFIRSTNEGATE 4
#define SFIRSTSUM 6
#define SPLUSTIMES 21
#define SMINUSTIMES 22
#define SFIRSTFUNC 8

int getkey (void);
int editstring (char *s, char *legal, int maxlength);
int getint (int *number, int low, int high);
void getinput (int c);
void scroll (int direction, int lines, int x1, int y1, 
  int x2, int y2, int attrib);
void setcursor (unsigned int shape);
void writef (int col, int row, int color, int width, 
  char *format, ...);
void printcol (void);
void printrow (void);
void displaycell (int col, int row, int highlighting, 
  int updating);
void displaycol (int col, int updating);
void displayrow (int row, int updating);
void displayscreen (int updating);
void clearinput (void);
void changecursor (int insmode);
void showcelltype (void);
double parse (char *s, int *att);
int alloctext (int col, int row, char *s);
int allocvalue (int col, int row, double amt);
int allocformula (int col, int row, char *s, double amt);
void deletecell (int col, int row, int display);
void printfreemem (void);
void moverowup (void);
void moverowdown (void);
void movecolleft (void);
void movecolright (void);
void recalc (void);
void changeautocalc (int newmode);
void changeformdisplay (int newmode);
void errormsg (char *s);
void colstring (int col, char *colstr);
void centercolstring (int col, char *colstr);
void setleftcol (void);
void setrightcol (void);
void settoprow (void);
void setbottomrow (void);
void setlastcol (void);
void setlastrow (void);
void act (char *s);
void initvars (void);
int getcommand (char *msgstr, char *comstr);
void mainmenu (void);
void editcell (CELLPTR ecell);
int setoflags (int col, int row, int display);
void clearoflags (int col, int row, int display);
void updateoflags (int col, int row, int display);
void loadsheet (char *filename);
int getcell (int *col, int *row);
char *cellstring (int col, int row, int *color, 
  int formatting);
void writeprompt (char *prompt);
int getyesno (int *yesno, char *prompt);
void swap (int *val1, int *val2);
void redrawscreen (void);
void checkforsave (void);
void savesheet (void);
int formulastart (char **input, int *col, int *row);
int rowwidth (int row);
void fixformula (int col, int row, int action, 
  int place);
void clearlastcol (void);
void run (void);
void gotocell (void);
int setmem (void *Destination, unsigned int Length, 
  char Fill);
int movmem (const void *Source, void *Destination, 
  unsigned int Length);
void clrscr (void);
void gotoxy (int x, int y);
void window (int left, int top, int right, int bottom);
void movetext (int left, int top, int right, int bottom,
  int newleft, int newtop);
BOOL iscorrectkey (VOID);
void fixformula2 (int col, int row);
void act2 (char *s, double value, int attrib);
int nexttoken (void);
void reduce (int reduction);

extern MEMORYSTATUS memstatus;
extern CONSOLE_CURSOR_INFO curinfo;
extern INPUT_RECORD inp;
extern HANDLE si, so;
extern DWORD written;
extern BOOL correctkey;
extern COORD coord;
extern CHAR_INFO charinfo;
extern SMALL_RECT R;
extern unsigned int shortcursor, tallcursor, nocursor, 
  c, ac, outc;
extern int leftcol, rightcol, toprow, bottomrow, curcol, currow, lastcol, 
  lastrow, curcolb, currowb, curcolc, currowc, 
  curcolcb, currowcb, i, j, leftcolb, toprowb, loading;
extern CELLPTR cell [MAXCOLS] [MAXROWS], curcell;
extern unsigned char format [MAXCOLS] [MAXROWS];
extern unsigned char colwidth [MAXCOLS];
extern unsigned char colstart [SCREENCOLS];
extern char changed, formdisplay, autocalc, stop,
  str [MAXINPUT + 1];

