#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "concalc.h"

//gets key and removes input message
INT getkey (VOID)
{
  do
    ReadConsoleInput (si, &inp, 1, (LPDWORD) &written);
  while (iscorrectkey () == FALSE);
  c = inp.Event.KeyEvent.wVirtualKeyCode;
  ac = inp.Event.KeyEvent.uChar.AsciiChar;
  outc = 0;
  if (ac != 0 && c != 110 && c != 67 && c != 86 && 
    c != 9)
    return (ac);
  if (c == 36) outc = HOMEKEY;
  if (c == 35) outc = ENDKEY;
  if (c == 38) outc = UPKEY;
  if (c == 40) outc = DOWNKEY;
  if (c == 33) outc = PGUPKEY;
  if (c == 34) outc = PGDNKEY;
  if (c == 37) outc = LEFTKEY;
  if (c == 110) outc = DELKEY;
  if (c == 45) outc = INSKEY;
  if (c == 39) outc = RIGHTKEY;
  if (c == 120) outc = F9;
  if (c == 113) outc = F2;
  if (c == 9) outc = TABKEY;
  if (c == 191) outc = '^';
  if (c == 115 && 
    ((inp.Event.KeyEvent.dwControlKeyState |  
    RIGHT_ALT_PRESSED) ==
    inp.Event.KeyEvent.dwControlKeyState || 
    (inp.Event.KeyEvent.dwControlKeyState |  
    LEFT_ALT_PRESSED) ==
    inp.Event.KeyEvent.dwControlKeyState)) 
    outc = ALTF4;
  else if (c == 115)
    outc = F4;
  if (c == 67 && 
    ((inp.Event.KeyEvent.dwControlKeyState |  
    RIGHT_CTRL_PRESSED) ==
    inp.Event.KeyEvent.dwControlKeyState || 
    (inp.Event.KeyEvent.dwControlKeyState |  
    LEFT_CTRL_PRESSED) ==
    inp.Event.KeyEvent.dwControlKeyState)) 
    outc = CTRLC;
  else if (c == 67)
    outc = ac;
  if (c == 86 && 
    ((inp.Event.KeyEvent.dwControlKeyState |  
    RIGHT_CTRL_PRESSED) ==
    inp.Event.KeyEvent.dwControlKeyState || 
    (inp.Event.KeyEvent.dwControlKeyState |  
    LEFT_CTRL_PRESSED) ==
    inp.Event.KeyEvent.dwControlKeyState)) 
    outc = CTRLV;
  else if (c == 86)
    outc = ac;
  if (c == 37 && 
    ((inp.Event.KeyEvent.dwControlKeyState |  
    RIGHT_CTRL_PRESSED) ==
    inp.Event.KeyEvent.dwControlKeyState || 
    (inp.Event.KeyEvent.dwControlKeyState |  
    LEFT_CTRL_PRESSED) ==
    inp.Event.KeyEvent.dwControlKeyState)) 
    outc = CTRLLEFTKEY;
  if (c == 39 && 
    ((inp.Event.KeyEvent.dwControlKeyState |  
    RIGHT_CTRL_PRESSED) ==
    inp.Event.KeyEvent.dwControlKeyState || 
    (inp.Event.KeyEvent.dwControlKeyState |  
    LEFT_CTRL_PRESSED) ==
    inp.Event.KeyEvent.dwControlKeyState)) 
    outc = CTRLRIGHTKEY;
  if (c == 37 && 
    (inp.Event.KeyEvent.dwControlKeyState |  
    SHIFT_PRESSED) ==
    inp.Event.KeyEvent.dwControlKeyState)
    outc = SHIFTLEFTKEY;
  if (c == 39 && 
    (inp.Event.KeyEvent.dwControlKeyState |  
    SHIFT_PRESSED) ==
    inp.Event.KeyEvent.dwControlKeyState)
    outc = SHIFTRIGHTKEY;
  if (c == 38 && 
    (inp.Event.KeyEvent.dwControlKeyState |  
    SHIFT_PRESSED) ==
    inp.Event.KeyEvent.dwControlKeyState)
    outc = SHIFTUPKEY;
  if (c == 40 && 
    (inp.Event.KeyEvent.dwControlKeyState |  
    SHIFT_PRESSED) ==
    inp.Event.KeyEvent.dwControlKeyState)
    outc = SHIFTDOWNKEY;
  return (outc);
}

//checks whether pressed key have to be processed
BOOL iscorrectkey (VOID)
{
  c = inp.Event.KeyEvent.wVirtualKeyCode;
  correctkey = FALSE;
  if (inp.Event.KeyEvent.bKeyDown == TRUE && c != 16)
  {
    if (inp.Event.KeyEvent.uChar.AsciiChar != 0)
      correctkey = TRUE;
    else if ((c >= 33 && c <= 40) || c == 110 ||
      c == 45 || c == 120 || c == 113 || c == 67 ||
      c == 86 || c == 115 || c == 191)
      correctkey = TRUE;
  }
  return (correctkey);
}

//allows the user to edit a string with only certain 
//characters allowed. returns TRUE if ESC was not 
//pressed, FALSE if ESC was pressed
int editstring (char *s, char *legal, int maxlength)
{
  int c, len = strlen(s), pos = len, insert = TRUE;
  changecursor(insert);
  do
  {
    writef (1, 25, TEXTCOLOR, 79, "%s", s);
    gotoxy (pos + 1, 25);
    switch (c = getkey())
    {
      case HOMEKEY: pos = 0; break;
      case ENDKEY: pos = len; break;
      
      case INSKEY:
        insert = !insert;
        changecursor (insert);
      break;
      
      case LEFTKEY: if (pos > 0) pos--; break;
      case RIGHTKEY: if (pos < len) pos++; break;
      
      case BS:
        if (pos > 0)
        {
          movmem (&s [pos], &s [pos - 1], len - pos + 1);
          pos--;
          len--;
        }
      break;
      
      case DELKEY:
        if (pos < len)
        {
          movmem (&s [pos + 1], &s [pos], len - pos);
          len--;
        }
      break;
      
      case CR: case TABKEY: case F4: case CTRLLEFTKEY:
      case CTRLRIGHTKEY: case PGUPKEY: case PGDNKEY:
      case CTRLC: case CTRLV: case ALTF4:
      break;
      
      case UPKEY: c = CR; break;
      case DOWNKEY: c = CR; break;
      case ESC: len = 0; break;
      
      default:
        if ((legal [0] == 0 || strchr (legal, c) != NULL) &&
          len < maxlength)
        {
          if (insert)
          {
            memmove (&s [pos + 1], &s [pos], len - 
              pos + 1);
            len++;
          }
          else
            if (pos >= len) len++;
          s [pos++] = c;
        }
      break;
    }
    s [len] = 0;
  } 
  while (c != CR && c != ESC);
  clearinput ();
  changecursor (FALSE);
  setcursor (nocursor);
  return (c != ESC);
}

//reads and acts on an input string from the keyboard 
//that started with c
void getinput (int c)
{
  char s [MAXINPUT + 1];
  s[0] = c;
  s[1] = 0;
  if (!editstring (s, "", MAXINPUT) || s[0] == 0) return;
  act (s);
  changed = TRUE;
}

//reads in a positive integer from low to high
int getint (int *number, int low, int high)
{
  int i, good = FALSE;
  char s [5], message [81];
  s[0] = 0;
  sprintf (message, MSGBADNUMBER, low, high);
  do
  {
    if (!editstring (s, "1234567890", 4)) return (FALSE);
    i = atoi (s);
    if ((good = (i >= low && i <= high)) == 0) 
      errormsg (message);
  } 
  while (!good);
  *number = i;
  return (TRUE);
}

//reads in a cell name that was typed in, returns FALSE 
//if ESC was pressed
int getcell (int *col, int *row)
{
  int first = TRUE, good = FALSE, oldcol = *col, 
    oldrow = *row, len, numlen = rowwidth (MAXROWS);
  char data [10], *input, *start, numstring [6];
  data[0] = 0;
  do
  {
    if (!first) errormsg (MSGBADCELL);
    first = FALSE;
    input = data;
    if (!editstring (data, "", numlen + 2))
    {
      *col = oldcol;
      *row = oldrow;
      return (FALSE);
    }
    *col = toupper (*(input++)) - 'A';
    if (isalpha (*input))
    {
      *col *= 26;
      *col += toupper (*(input++)) - 'A' + 26;
    }
    if (*col >= MAXCOLS) continue;
    start = input;
    for (len = 0; len < numlen; len++)
      if (!isdigit (*(input++)))
      {
        input--;
        break;
      }
    if (len == 0) continue;
    strncpy (numstring, start, len);
    numstring [len] = 0;
    *row = atoi (numstring) - 1;
    if ((*row >= MAXROWS) || (*row == -1) || 
      (*input != 0)) continue;
    good = TRUE;
  } 
  while (!good);
  return (TRUE);
}

//prints a prompt and gets a yes or no answer, returns 
//TRUE if ESC was pressed, FALSE if not
int getyesno (int *yesno, char *prompt)
{
  writeprompt (prompt);
  setcursor (shortcursor);
  do
  {
    *yesno = toupper (getkey ());
    if (*yesno == ESC)
    {
      setcursor (nocursor);
      return (FALSE);
    }
  } 
  while (strchr ( KEYS_YESNO , *yesno) == NULL);
  setcursor (nocursor);
  return (TRUE);
}

